# Conditional build:
%bcond_without	system_wlroots	# Link with system wlroots

%define		wlroots_ver	0.18.2

Summary:	A Wayland kiosk
Name:		cage
Version:	0.2.0
Release:	1
License:	MIT
Group:		Applications
Source0:	https://github.com/cage-kiosk/cage/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	35843f54f096322d78d7802c94258bc4
Source1:	https://gitlab.freedesktop.org/wlroots/wlroots/-/releases/%{wlroots_ver}/downloads/wlroots-%{wlroots_ver}.tar.gz
# Source1-md5:	f230118c020e3ac40813823d4156d324
Patch0:		wlroots-x32.patch
URL:		https://www.hjdskes.nl/projects/cage/
BuildRequires:	meson >= 0.58.1
BuildRequires:	ninja
BuildRequires:	pixman-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 2.042
BuildRequires:	scdoc >= 1.9.2
BuildRequires:	wayland-devel
BuildRequires:	wayland-protocols >= 1.14
BuildRequires:	xorg-lib-libxkbcommon-devel
%if %{with system_wlroots}
BuildRequires:	wlroots0.18-devel
%else
BuildRequires:	EGL-devel
BuildRequires:	Mesa-libgbm-devel >= 21.1.0
BuildRequires:	OpenGLESv2-devel
BuildRequires:	Vulkan-Loader-devel >= 1.2.182
BuildRequires:	glslang >= 11.0.0
BuildRequires:	hwdata >= 0.364
BuildRequires:	libdrm-devel >= 2.4.113
BuildRequires:	libinput-devel >= 1.19.0
BuildRequires:	libseat-devel >= 0.2.0
BuildRequires:	libxcb-devel
BuildRequires:	pixman-devel
BuildRequires:	udev-devel
BuildRequires:	wayland-protocols >= 1.27
BuildRequires:	xcb-util-errors-devel
BuildRequires:	xcb-util-renderutil-devel
BuildRequires:	xcb-util-wm-devel
BuildRequires:	xorg-xserver-Xwayland-devel
%endif
Requires:	xorg-xserver-Xwayland
%if %{without system_wlroots}
Requires:	Mesa-libgbm >= 21.1.0
Requires:	Vulkan-Loader >= 1.2.182
Requires:	libdrm >= 2.4.113
Requires:	libinput >= 1.19.0
Requires:	libseat >= 0.2.0
Requires:	wayland >= 1.21
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Cage is a kiosk compositor for Wayland. A kiosk is a window manager
(in the X11 world) or compositor (in the Wayland world) that is
designed for a user experience wherein user interaction and activities
outside the scope of the running application are prevented. That is, a
kiosk compositor displays a single maximized application at a time and
prevents the user from interacting with anything but this application.

%prep
%setup -q %{!?with_system_wlroots:-a1}

%if %{without system_wlroots}
%{__mkdir} subprojects
%{__mv} wlroots-%{wlroots_ver} subprojects/wlroots
%patch -P0 -p1 -d subprojects/wlroots
%endif

%build
%meson \
%if %{without system_wlroots}
	--force-fallback-for=wlroots \
	-Dwlroots:default_library=static \
	-Dwlroots:examples=false
%endif

%meson_build

%install
rm -rf $RPM_BUILD_ROOT

%meson_install

%if %{without system_wlroots}
%{__rm} -r $RPM_BUILD_ROOT{%{_includedir}/wlroots-0.18,%{_libdir}/libwlroots-0.18.a,%{_pkgconfigdir}/wlroots-0.18.pc}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_bindir}/cage
%{_mandir}/man1/cage.1*
%changelog
* Thu Feb 20 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/cage.git;a=log;h=master

* Thu Feb 20 2025 Jan Palus <atler@pld-linux.org> 399378d
- up to 0.2.0

* Thu Feb 20 2025 Jan Palus <atler@pld-linux.org> 5c08ec7
- use new meson macros

* Thu Feb 20 2025 Jan Palus <atler@pld-linux.org> 65148a0
- use %patch -P

* Sat Jun 29 2024 Jan Palus <atler@pld-linux.org> 68e0fbb
- force fallback when building without system wlroots

* Sat Jun 29 2024 Jan Palus <atler@pld-linux.org> afcdb3a
- add system_wlroots bcond (disabled by default); rel 2

* Fri Jul 28 2023 Jan Palus <atler@pld-linux.org> d123046
- up to 0.1.5

* Sun Dec 25 2022 Jan Palus <atler@pld-linux.org> d3b7ada
- update to latest git snap compatible with wlroots 0.16; rel 4

* Mon Mar 21 2022 Jan Palus <atler@pld-linux.org> 65949b8
- R: xorg-xserver-Xwayland; rel 3

* Sun Jan 23 2022 Jan Rękorajski <baggins@pld-linux.org> cb12afe
- upstream patch form wlroots 0.15, rel 2

* Thu Dec 30 2021 Jan Palus <atler@pld-linux.org> b259897
- new

